// Code generated by goctl. DO NOT EDIT.
package types

type ActiveReward struct {
	TotalReward float64          `json:"total_reward"`
	Today       ActiveRewardData `json:"today"`   // 今日数据
	Last7D      ActiveRewardData `json:"last7d"`  // 近7天数据
	Last30D     ActiveRewardData `json:"last30d"` // 近30天数据
}

type ActiveRewardData struct {
	NewActiveReward   float64 `json:"active_reward"`
	SubPromoteReward  float64 `json:"sub_promote_reward"`
	SubUpgradeReward  float64 `json:"sub_upgrade_reward"`
	SubWithdrawReward float64 `json:"sub_withdraw_reward"`
}

type AgentActivateMembershipReq struct {
	Type string `json:"type,oneof=VIP SVIP"` // 会员类型：vip/svip
}

type AgentActivateMembershipResp struct {
	Id string `json:"id"`
}

type AgentApplyReq struct {
	Region   string `json:"region"`
	Mobile   string `json:"mobile"`
	WechatID string `json:"wechat_id"`
	Code     string `json:"code"`
	Ancestor string `json:"ancestor,optional"`
}

type AgentApplyResp struct {
	AccessToken  string `json:"accessToken"`
	AccessExpire int64  `json:"accessExpire"`
	RefreshAfter int64  `json:"refreshAfter"`
}

type AgentAuditStatusResp struct {
	Status      int64  `json:"status"` // 0=待审核，1=审核通过，2=审核未通过
	AuditReason string `json:"audit_reason"`
}

type AgentGeneratingLinkReq struct {
	Product string `json:"product"`
	Price   string `json:"price"`
}

type AgentGeneratingLinkResp struct {
	LinkIdentifier string `json:"link_identifier"`
}

type AgentInfoResp struct {
	Status     int64  `json:"status"` // 0=待审核，1=审核通过，2=审核未通过，3=未申请
	IsAgent    bool   `json:"is_agent"`
	AgentID    int64  `json:"agent_id"`
	Level      string `json:"level"`
	Region     string `json:"region"`
	Mobile     string `json:"mobile"`
	WechatID   string `json:"wechat_id"`
	ExpiryTime string `json:"expiry_time"`
}

type AgentMembershipProductConfigReq struct {
	ProductID int64 `form:"product_id"`
}

type AgentMembershipProductConfigResp struct {
	AgentMembershipUserConfig AgentMembershipUserConfig `json:"agent_membership_user_config"`
	ProductConfig             ProductConfig             `json:"product_config"`
	PriceIncreaseMax          float64                   `json:"price_increase_max"`
	PriceIncreaseAmount       float64                   `json:"price_increase_amount"`
	PriceRatio                float64                   `json:"price_ratio"`
}

type AgentMembershipUserConfig struct {
	ProductID           int64   `json:"product_id"`
	PriceIncreaseAmount float64 `json:"price_increase_amount"`
	PriceRangeFrom      float64 `json:"price_range_from"`
	PriceRangeTo        float64 `json:"price_range_to"`
	PriceRatio          float64 `json:"price_ratio"`
}

type AgentProductConfig struct {
	ProductID         int64   `json:"product_id"`
	CostPrice         float64 `json:"cost_price"`
	PriceRangeMin     float64 `json:"price_range_min"`
	PriceRangeMax     float64 `json:"price_range_max"`
	PPricingStandard  float64 `json:"p_pricing_standard"`
	POverpricingRatio float64 `json:"p_overpricing_ratio"`
	APricingStandard  float64 `json:"a_pricing_standard"`
	APricingEnd       float64 `json:"a_pricing_end"`
	AOverpricingRatio float64 `json:"a_overpricing_ratio"`
}

type AgentProductConfigResp struct {
	AgentProductConfig []AgentProductConfig
}

type AgentSubordinateContributionDetail struct {
	ID         int64   `json:"id"`
	CreateTime string  `json:"create_time"`
	Amount     float64 `json:"amount"`
	Type       string  `json:"type"`
}

type AgentSubordinateContributionStats struct {
	CostCount                   int64   `json:"cost_count"`                     // 成本扣除次数
	CostAmount                  float64 `json:"cost_amount"`                    // 成本扣除总额
	PricingCount                int64   `json:"pricing_count"`                  // 定价扣除次数
	PricingAmount               float64 `json:"pricing_amount"`                 // 定价扣除总额
	DescendantPromotionCount    int64   `json:"descendant_promotion_count"`     // 下级推广次数
	DescendantPromotionAmount   float64 `json:"descendant_promotion_amount"`    // 下级推广总额
	DescendantUpgradeVipCount   int64   `json:"descendant_upgrade_vip_count"`   // 下级升级VIP次数
	DescendantUpgradeVipAmount  float64 `json:"descendant_upgrade_vip_amount"`  // 下级升级VIP总额
	DescendantUpgradeSvipCount  int64   `json:"descendant_upgrade_svip_count"`  // 下级升级SVIP次数
	DescendantUpgradeSvipAmount float64 `json:"descendant_upgrade_svip_amount"` // 下级升级SVIP总额
	DescendantStayActiveCount   int64   `json:"descendant_stay_active_count"`   // 下级保持活跃次数
	DescendantStayActiveAmount  float64 `json:"descendant_stay_active_amount"`  // 下级保持活跃总额
	DescendantNewActiveCount    int64   `json:"descendant_new_active_count"`    // 下级新增活跃次数
	DescendantNewActiveAmount   float64 `json:"descendant_new_active_amount"`   // 下级新增活跃总额
	DescendantWithdrawCount     int64   `json:"descendant_withdraw_count"`      // 下级提现次数
	DescendantWithdrawAmount    float64 `json:"descendant_withdraw_amount"`     // 下级提现总额
}

type AgentSubordinateList struct {
	ID                int64   `json:"id"`
	Mobile            string  `json:"mobile"`
	CreateTime        string  `json:"create_time"`
	LevelName         string  `json:"level_name"`
	TotalOrders       int64   `json:"total_orders"`       // 总单量
	TotalEarnings     float64 `json:"total_earnings"`     // 总金额
	TotalContribution float64 `json:"total_contribution"` // 总贡献
}

type BindMobileReq struct {
	Mobile string `json:"mobile" validate:"required,mobile"`
	Code   string `json:"code" validate:"required"`
}

type BindMobileResp struct {
}

type Commission struct {
	ProductName string  `json:"product_name"`
	Amount      float64 `json:"amount"`
	CreateTime  string  `json:"create_time"`
}

type DirectPushReport struct {
	TotalCommission float64         `json:"total_commission"`
	TotalReport     int             `json:"total_report"`
	Today           TimeRangeReport `json:"today"`   // 近24小时数据
	Last7D          TimeRangeReport `json:"last7d"`  // 近7天数据
	Last30D         TimeRangeReport `json:"last30d"` // 近30天数据
}

type Feature struct {
	ID    int64  `json:"id"`     // 功能ID
	ApiID string `json:"api_id"` // API标识
	Name  string `json:"name"`   // 功能描述
}

type GetAgentRevenueInfoReq struct {
}

type GetAgentRevenueInfoResp struct {
	Balance       float64          `json:"balance"`
	FrozenBalance float64          `json:"frozen_balance"`
	TotalEarnings float64          `json:"total_earnings"`
	DirectPush    DirectPushReport `json:"direct_push"`   // 直推报告数据
	ActiveReward  ActiveReward     `json:"active_reward"` // 活跃下级奖励数据
}

type GetAgentSubordinateContributionDetailReq struct {
	Page          int64 `form:"page"`           // 页码
	PageSize      int64 `form:"page_size"`      // 每页数据量
	SubordinateID int64 `form:"subordinate_id"` // 下级ID
}

type GetAgentSubordinateContributionDetailResp struct {
	Mobile            string                               `json:"mobile"`
	Total             int64                                `json:"total"` // 总记录数
	CreateTime        string                               `json:"create_time"`
	TotalEarnings     float64                              `json:"total_earnings"`     // 总金额
	TotalContribution float64                              `json:"total_contribution"` // 总贡献
	TotalOrders       int64                                `json:"total_orders"`       // 总单量
	LevelName         string                               `json:"level_name"`         // 等级名称
	List              []AgentSubordinateContributionDetail `json:"list"`               // 查询列表
	Stats             AgentSubordinateContributionStats    `json:"stats"`              // 统计数据
}

type GetAgentSubordinateListReq struct {
	Page     int64 `form:"page"`      // 页码
	PageSize int64 `form:"page_size"` // 每页数据量
}

type GetAgentSubordinateListResp struct {
	Total int64                  `json:"total"` // 总记录数
	List  []AgentSubordinateList `json:"list"`  // 查询列表
}

type GetCommissionReq struct {
	Page     int64 `form:"page"`      // 页码
	PageSize int64 `form:"page_size"` // 每页数据量
}

type GetCommissionResp struct {
	Total int64        `json:"total"` // 总记录数
	List  []Commission `json:"list"`  // 查询列表
}

type GetLinkDataReq struct {
	LinkIdentifier string `form:"link_identifier"`
}

type GetLinkDataResp struct {
	Product
}

type GetNotificationsResp struct {
	Notifications []Notification `json:"notifications"` // 通知列表
	Total         int64          `json:"total"`         // 总记录数
}

type GetProductByEnRequest struct {
	ProductEn string `path:"product_en"`
}

type GetProductByIDRequest struct {
	Id int64 `path:"id"`
}

type GetRewardsReq struct {
	Page     int64 `form:"page"`      // 页码
	PageSize int64 `form:"page_size"` // 每页数据量
}

type GetRewardsResp struct {
	Total int64     `json:"total"` // 总记录数
	List  []Rewards `json:"list"`  // 查询列表
}

type GetWithdrawalReq struct {
	Page     int64 `form:"page"`      // 页码
	PageSize int64 `form:"page_size"` // 每页数据量
}

type GetWithdrawalResp struct {
	Total int64        `json:"total"` // 总记录数
	List  []Withdrawal `json:"list"`  // 查询列表
}

type HealthCheckResp struct {
	Status  string `json:"status"`  // 服务状态
	Message string `json:"message"` // 状态信息
}

type IapCallbackReq struct {
	OrderID            int64  `json:"order_id" validate:"required"`
	TransactionReceipt string `json:"transaction_receipt" validate:"required"`
}

type MobileCodeLoginReq struct {
	Mobile string `json:"mobile"`
	Code   string `json:"code" validate:"required"`
}

type MobileCodeLoginResp struct {
	AccessToken  string `json:"accessToken"`
	AccessExpire int64  `json:"accessExpire"`
	RefreshAfter int64  `json:"refreshAfter"`
}

type MobileLoginReq struct {
	Mobile   string `json:"mobile" validate:"required,mobile"`
	Password string `json:"password" validate:"required"`
}

type MobileLoginResp struct {
	AccessToken  string `json:"accessToken"`
	AccessExpire int64  `json:"accessExpire"`
	RefreshAfter int64  `json:"refreshAfter"`
}

type Notification struct {
	Title            string `json:"title"`            // 通知标题
	Content          string `json:"content"`          // 通知内容 (富文本)
	NotificationPage string `json:"notificationPage"` // 通知页面
	StartDate        string `json:"startDate"`        // 通知开始日期，格式 "YYYY-MM-DD"
	EndDate          string `json:"endDate"`          // 通知结束日期，格式 "YYYY-MM-DD"
	StartTime        string `json:"startTime"`        // 每天通知开始时间，格式 "HH:MM:SS"
	EndTime          string `json:"endTime"`          // 每天通知结束时间，格式 "HH:MM:SS"
}

type PaymentCheckReq struct {
	OrderNo string `json:"order_no" validate:"required"`
}

type PaymentCheckResp struct {
	Type   string `json:"type"`
	Status string `json:"status"`
}

type PaymentReq struct {
	Id        string `json:"id"`
	PayMethod string `json:"pay_method"`
	PayType   string `json:"pay_type" validate:"required,oneof=query agent_vip"`
}

type PaymentResp struct {
	PrepayData interface{} `json:"prepay_data"`
	PrepayId   string      `json:"prepay_id"`
	OrderNo    string      `json:"order_no"`
}

type Product struct {
	ProductName string    `json:"product_name"`
	ProductEn   string    `json:"product_en"`
	Description string    `json:"description"`
	Notes       string    `json:"notes,optional"`
	SellPrice   float64   `json:"sell_price"`
	Features    []Feature `json:"features"` // 关联功能列表
}

type ProductConfig struct {
	ProductID     int64   `json:"product_id"`
	CostPrice     float64 `json:"cost_price"`
	PriceRangeMin float64 `json:"price_range_min"`
	PriceRangeMax float64 `json:"price_range_max"`
}

type ProductResponse struct {
	Product
}

type Query struct {
	Id          int64                  `json:"id"`           // 主键ID
	OrderId     int64                  `json:"order_id"`     // 订单ID
	UserId      int64                  `json:"user_id"`      // 用户ID
	ProductName string                 `json:"product_name"` // 产品ID
	QueryParams map[string]interface{} `json:"query_params"`
	QueryData   []QueryItem            `json:"query_data"`
	CreateTime  string                 `json:"create_time"` // 创建时间
	UpdateTime  string                 `json:"update_time"` // 更新时间
	QueryState  string                 `json:"query_state"` // 查询状态
}

type QueryDetailByOrderIdReq struct {
	OrderId int64 `path:"order_id"`
}

type QueryDetailByOrderIdResp struct {
	Query
}

type QueryDetailByOrderNoReq struct {
	OrderNo string `path:"order_no"`
}

type QueryDetailByOrderNoResp struct {
	Query
}

type QueryExampleReq struct {
	Feature string `form:"feature"`
}

type QueryExampleResp struct {
	Query
}

type QueryGenerateShareLinkReq struct {
	OrderId *int64  `json:"order_id,optional"`
	OrderNo *string `json:"order_no,optional"`
}

type QueryGenerateShareLinkResp struct {
	ShareLink string `json:"share_link"`
}

type QueryItem struct {
	Feature interface{} `json:"feature"`
	Data    interface{} `json:"data"` // 这里可以是 map 或 具体的 struct
}

type QueryListReq struct {
	Page     int64 `form:"page"`      // 页码
	PageSize int64 `form:"page_size"` // 每页数据量
}

type QueryListResp struct {
	Total int64   `json:"total"` // 总记录数
	List  []Query `json:"list"`  // 查询列表
}

type QueryProvisionalOrderReq struct {
	Id string `path:"id"`
}

type QueryProvisionalOrderResp struct {
	Name    string  `json:"name"`
	IdCard  string  `json:"id_card"`
	Mobile  string  `json:"mobile"`
	Product Product `json:"product"`
}

type QueryReq struct {
	Data string `json:"data" validate:"required"`
}

type QueryResp struct {
	Id string `json:"id"`
}

type QueryRetryReq struct {
	Id int64 `path:"id"`
}

type QueryRetryResp struct {
	Query
}

type QueryServiceReq struct {
	Product         string `path:"product"`
	Data            string `json:"data" validate:"required"`
	AgentIdentifier string `json:"agent_identifier,optional"`
	App             bool   `json:"app,optional"`
}

type QueryServiceResp struct {
	Id           string `json:"id"`
	AccessToken  string `json:"accessToken"`
	AccessExpire int64  `json:"accessExpire"`
	RefreshAfter int64  `json:"refreshAfter"`
}

type QueryShareDetailReq struct {
	Id string `path:"id"`
}

type QueryShareDetailResp struct {
	Query
}

type QuerySingleTestReq struct {
	Params map[string]interface{} `json:"params"`
	Api    string                 `json:"api"`
}

type QuerySingleTestResp struct {
	Data interface{} `json:"data"`
	Api  string      `json:"api"`
}

type RegisterReq struct {
	Mobile   string `json:"mobile" validate:"required,mobile"`
	Password string `json:"password" validate:"required,min=11,max=11,password"`
	Code     string `json:"code" validate:"required"`
}

type RegisterResp struct {
	AccessToken  string `json:"accessToken"`
	AccessExpire int64  `json:"accessExpire"`
	RefreshAfter int64  `json:"refreshAfter"`
}

type Rewards struct {
	Type       string  `json:"type"`
	Amount     float64 `json:"amount"`
	CreateTime string  `json:"create_time"`
}

type SaveAgentMembershipUserConfigReq struct {
	ProductID           int64   `json:"product_id"`
	PriceIncreaseAmount float64 `json:"price_increase_amount"`
	PriceRangeFrom      float64 `json:"price_range_from"`
	PriceRangeTo        float64 `json:"price_range_to"`
	PriceRatio          float64 `json:"price_ratio"`
}

type TimeRangeReport struct {
	Commission float64 `json:"commission"` // 佣金
	Report     int     `json:"report"`     // 报告量
}

type UpdateQueryDataReq struct {
	Id        int64  `json:"id"`         // 查询ID
	QueryData string `json:"query_data"` // 查询数据(未加密的JSON)
}

type UpdateQueryDataResp struct {
	Id        int64  `json:"id"`
	UpdatedAt string `json:"updated_at"` // 更新时间
}

type User struct {
	Id       int64  `json:"id"`
	Mobile   string `json:"mobile"`
	NickName string `json:"nickName"`
}

type UserInfoResp struct {
	UserInfo User `json:"userInfo"`
}

type WXH5AuthReq struct {
	Code string `json:"code"`
}

type WXH5AuthResp struct {
	AccessToken  string `json:"accessToken"`
	AccessExpire int64  `json:"accessExpire"`
	RefreshAfter int64  `json:"refreshAfter"`
}

type WXMiniAuthReq struct {
	Code          string `json:"code"`
	IV            string `json:"iv"`
	EncryptedData string `json:"encryptedData"`
}

type WXMiniAuthResp struct {
	AccessToken  string `json:"accessToken"`
	AccessExpire int64  `json:"accessExpire"`
	RefreshAfter int64  `json:"refreshAfter"`
}

type Withdrawal struct {
	Status       int64   `json:"status"`
	Amount       float64 `json:"amount"`
	WithdrawalNo string  `json:"withdrawal_no"`
	Remark       string  `json:"remark"`
	PayeeAccount string  `json:"payee_account"`
	CreateTime   string  `json:"create_time"`
}

type WithdrawalReq struct {
	Amount       float64 `json:"amount"` // 提现金额
	PayeeAccount string  `json:"payee_account"`
	PayeeName    string  `json:"payee_name"`
}

type WithdrawalResp struct {
	Status  int64  `json:"status"` // 1申请中  2成功  3失败
	FailMsg string `json:"fail_msg"`
}

type GetAppVersionResp struct {
	Version string `json:"version"`
	WgtUrl  string `json:"wgtUrl"`
}

type SendSmsReq struct {
	Mobile     string `json:"mobile" validate:"required,mobile"`
	ActionType string `json:"actionType" validate:"required,oneof=login register query agentApply bindMobile"`
}
